clear
xdel(winsid())

// Function to generate the experimental data
//m=2;
//b=1;
//
//x=[0:10]'
////yExp=m .* x +b+(rand(size(x,1),1)-0.5);
expData=[ 0.     0.7113249;
          1.     3.2560439;
          2.     4.5002211;
          3.     6.8303271;
          4.     9.1653811;
          5.    11.128392 ;
          6.    13.349745 ;
          7.    15.185731 ;
          8.    17.378216 ;
          9.    18.568374 ;
         10.    21.060849 ]

plot(expData(:,1),expData(:,2),"s")

// Functions to find the regression
function y=rectaError(p,M,x)
    y=expData(:,2)-(p(1) *x +p(2));
endfunction

function y=recta(X,p)
    y=(p(1) *X +p(2));
endfunction


// Levenberg-Marquardt regression
[pEst,v,info]=lsqrsolve([1;1],list(rectaError,expData(:,1)),size(expData,1))

plot(expData(:,1),recta(expData(:,1),pEst),"g")

// Estimate the statistical information
J=numderivative(list(rectaError,1,expData(:,1)),pEst)

wi2=(1/(11-2+1))*(expData(:,2)-recta(expData(:,1),pEst))'*(expData(:,2)-recta(expData(:,1),pEst))
W=1/wi2*eye(size(expData,1),size(expData,1))

// Covariance
Vp=inv(J'*W*J)
sigmaP=sqrt(diag(Vp))

corrMat=Vp./(sigmaP*sigmaP')


// Print the result, including statistical information
mprintf("Final set of parameters            Asymptotic Standard Error\n")
mprintf("=======================            ==========================\n")

mprintf("m               = %f          +/- %f       (%.3f%%)\n",pEst(1),sigmaP(1),sigmaP(1)/pEst(1)*100)
mprintf("b               = %f          +/- %f       (%.3f%%)\n",pEst(2),sigmaP(2),sigmaP(2)/pEst(2)*100)

mprintf("correlation matrix of the fit parameters:\n")

mprintf("                m         b      \n")
mprintf("m               %f        \n",corrMat(1,1))
mprintf("b              %f  %f \n",corrMat(2,1),corrMat(2,2))

